//----------------------------------------------------------------------//
// NyanFi																//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include "Global.h"
#include "Splash.h"

//---------------------------------------------------------------------------
USEFORM("RenDlg.cpp", RenameDlg);
USEFORM("SameDlg.cpp", SameNameDlg);
USEFORM("PrnImgDlg.cpp", PrintImgDlg);
USEFORM("OptDlg.cpp", OptionDlg);
USEFORM("PackDlg.cpp", PackArcDlg);
USEFORM("ShareDlg.cpp", NetShareDlg);
USEFORM("SrtModDlg.cpp", SortModeDlg);
USEFORM("SyncDlg.cpp", RegSyncDlg);
USEFORM("Splash.cpp", SplashForm);
USEFORM("KeyDlg.cpp", KeyListDlg);
USEFORM("LoupeFrm.cpp", LoupeForm);
USEFORM("JoinDlg.cpp", JoinTextDlg);
USEFORM("InpExDlg.cpp", InputExDlg);
USEFORM("InspectFrm.cpp", InspectForm);
USEFORM("MainFrm.cpp", NyanFiForm);
USEFORM("ModalScr.cpp", ModalScrForm);
USEFORM("MaskSelDlg.cpp", MaskSelectDlg);
USEFORM("MaskDlg.cpp", PathMaskDlg);
USEFORM("TabDlg.cpp", TabSetDlg);
USEFORM("XmlView.cpp", XmlViewer);
USEFORM("TaskDlg.cpp", TaskManDlg);
USEFORM("UserMdl.cpp", UserModule); /* TDataModule: File Type */
USEFORM("ColPicker.cpp", ColorPicker);
USEFORM("CompDlg.cpp", FileCompDlg);
USEFORM("ColDlg.cpp", ColorDlg);
USEFORM("ChmodDlg.cpp", FtpChmodDlg);
USEFORM("CmdListDlg.cpp", CmdFileListDlg);
USEFORM("CreDirsDlg.cpp", CreateDirsDlg);
USEFORM("DirDlg.cpp", RegDirDlg);
USEFORM("DistrDlg.cpp", DistributionDlg);
USEFORM("CvImgDlg.cpp", CvImageDlg);
USEFORM("CsvRecFrm.cpp", CsvRecForm);
USEFORM("CvEncDlg.cpp", CvTxtEncDlg);
USEFORM("About.cpp", AboutBox);
USEFORM("AppDlg.cpp", AppListDlg);
USEFORM("AskRep.cpp", AskRepDlg);
USEFORM("ChInfFrm.cpp", CharInfoForm);
USEFORM("BtnDlg.cpp", ToolBtnDlg);
USEFORM("BakDlg.cpp", BackupDlg);
USEFORM("BitmapFrm.cpp", BitmapForm);
USEFORM("DotDlg.cpp", DotNyanDlg);
USEFORM("HistDlg.cpp", DirHistoryDlg);
USEFORM("HistFrm.cpp", HistForm);
USEFORM("GrepOptDlg.cpp", GrepExOptDlg);
USEFORM("GifView.cpp", GifViewer);
USEFORM("InpCmds.cpp", InpCmdsDlg);
USEFORM("InpDir.cpp", InpDirDlg);
USEFORM("FileExtDlg.cpp", FileExtensionDlg);
USEFORM("FileInfDlg.cpp", FileInfoDlg);
USEFORM("ExeDlg.cpp", ExeCmdDlg);
USEFORM("DriveDlg.cpp", SelDriveDlg);
USEFORM("EditHistDlg.cpp", EditHistoryDlg);
USEFORM("FindDlg.cpp", FindFileDlg);
USEFORM("FuncDlg.cpp", FuncListDlg);
USEFORM("GenInfDlg.cpp", GeneralInfoDlg);
USEFORM("FtpDlg.cpp", FtpConnectDlg);
USEFORM("FindTag.cpp", FindTagForm);
USEFORM("FindTxtDlg.cpp", FindTextDlg);
USEFORM("ExTViewer.cpp", ExTxtViewer);

//---------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR lpCmdLine, int)
{
	bool restart   = false;
	bool duplicate = false;

	StartedCount = GetTickCount();

	//NIvV擾
	std::unique_ptr<TStringList> opt_lst(new TStringList());
	int args;
	LPTSTR *lplpszArgs = ::CommandLineToArgvW(lpCmdLine, &args);
	if (lplpszArgs) {
		for (int i = 0; i<args; ++i) opt_lst->Add(lplpszArgs[i]);
		LocalFree(lplpszArgs);
	}

	//INIt@C̐ݒ
	UnicodeString inam;
	for (int i=0; i<opt_lst->Count; i++) {
		UnicodeString lbuf = opt_lst->Strings[i];
		if (remove_top_s(lbuf, "-I"))
			inam = rel_to_absdir(exclude_quot(lbuf), ExtractFilePath(Application->ExeName));
	}
	if (inam.IsEmpty()) inam = ChangeFileExt(Application->ExeName, ".INI");

	//dNĂ邩`FbN
	try {
		std::unique_ptr<TStringList> ibuf(new TStringList());
		ibuf->LoadFromFile(inam, TEncoding::UTF8);
		duplicate = equal_1(ibuf->Values["MultiInstance"]);
	}
	catch (...) {
		;
	}

	//~[ebNXɂdN`FbN
	HANDLE hMutex = ::CreateMutex(NULL, FALSE, _T("NyanFi_is_running"));
	if (GetLastError()==ERROR_ALREADY_EXISTS) {
		//L
		HWND hPrimeWnd = get_PrimNyanWnd();
		if (hPrimeWnd) {
			IsPrimary = false;
			int cmdlen = lstrlen(lpCmdLine);
			if (cmdlen>0 || !duplicate) {
				HWND hApp = ::GetWindow(hPrimeWnd, GW_OWNER);
				if (::IsIconic(hApp)) ::SendMessage(hApp, WM_SYSCOMMAND, SC_RESTORE, 0);
				if (::IsIconic(hPrimeWnd)) ::SendMessage(hPrimeWnd, WM_SYSCOMMAND, SC_RESTORE, 0);
				::SetForegroundWindow(hPrimeWnd);
			}
			//R}hC̓e𑗂
			if (cmdlen>0) {
				COPYDATASTRUCT cd;
				cd.dwData = 1;
				cd.cbData = sizeof(_TCHAR) * (cmdlen + 1);
				cd.lpData = lpCmdLine;
				::SendMessage(hPrimeWnd, WM_COPYDATA, 0, (LPARAM)&cd);
				duplicate = false;
				for (int i=0; i<opt_lst->Count && !restart; i++)
					restart = SameText(opt_lst->Strings[i], "-Q");	//-Q or -q
			}
		}

		if (!restart && !duplicate) {	//ċNŖꍇdNɏI
			::CloseHandle(hMutex);
			return -1;
		}
	}

	//ċN̂߂Ɋ̏I҂(ő20b)
	if (restart) {
		bool ok = false;
		for (int i=0; i<200 && !ok; i++) if (::WaitForSingleObject(hMutex, 100)==WAIT_OBJECT_0) ok = true;
		if (!ok) {	//IȂ̂ŏI
			::CloseHandle(hMutex);
			return -1;
		}
		IsPrimary = true;
	}

	::CoInitialize(NULL);

	try {
		Screen->Cursor = crHourGlass;
		Application->Initialize();
		Application->MainFormOnTaskBar = true;

		//INIt@C̏
		IniFile = new UsrIniFile(inam);

		//XvbV\
		if (IniFile->ReadBoolGen(_T("ShowSplash"))) {
			SplashForm = new TSplashForm(Application);
			//o[W
			unsigned mj, mi, bl;
			if (GetProductVersion(Application->ExeName, mj, mi, bl)) {
				SplashForm->VerLabel->Caption = UnicodeString().sprintf(_T("V%.2f"), (mj*100 + mi*10 + bl)/100.0);
				SplashForm->Show();
				SplashForm->SetMsgLabel(_T("..."));
			}
		}

		Application->Title = get_NewTitle(IsPrimary);
		Application->CreateForm(__classid(TUserModule), &UserModule);
		Application->CreateForm(__classid(TNyanFiForm), &NyanFiForm);
		Application->CreateForm(__classid(TBitmapForm), &BitmapForm);
		Application->CreateForm(__classid(TCharInfoForm), &CharInfoForm);
		Application->CreateForm(__classid(TCmdFileListDlg), &CmdFileListDlg);
		Application->CreateForm(__classid(TColorPicker), &ColorPicker);
		Application->CreateForm(__classid(TCsvRecForm), &CsvRecForm);
		Application->CreateForm(__classid(TDirHistoryDlg), &DirHistoryDlg);
		Application->CreateForm(__classid(TEditHistoryDlg), &EditHistoryDlg);
		Application->CreateForm(__classid(TFileInfoDlg), &FileInfoDlg);
		Application->CreateForm(__classid(TFindTextDlg), &FindTextDlg);
		Application->CreateForm(__classid(TFuncListDlg), &FuncListDlg);
		Application->CreateForm(__classid(TGeneralInfoDlg), &GeneralInfoDlg);
		Application->CreateForm(__classid(TGifViewer), &GifViewer);
		Application->CreateForm(__classid(THistForm), &HistForm);
		Application->CreateForm(__classid(TInpCmdsDlg), &InpCmdsDlg);
		Application->CreateForm(__classid(TInputExDlg), &InputExDlg);
		Application->CreateForm(__classid(TInspectForm), &InspectForm);
		Application->CreateForm(__classid(TKeyListDlg), &KeyListDlg);
		Application->CreateForm(__classid(TLoupeForm), &LoupeForm);
		Application->CreateForm(__classid(TMaskSelectDlg), &MaskSelectDlg);
		Application->CreateForm(__classid(TModalScrForm), &ModalScrForm);
		Application->CreateForm(__classid(TSameNameDlg), &SameNameDlg);
		Application->CreateForm(__classid(TSelDriveDlg), &SelDriveDlg);
		Application->CreateForm(__classid(TSortModeDlg), &SortModeDlg);
		Application->CreateForm(__classid(TColorDlg), &ColorDlg);
		Application->CreateForm(__classid(TInpDirDlg), &InpDirDlg);
		cursor_Default();
		Application->Run();
	}
	catch (Exception &exception) {
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try {
			throw Exception(EmptyStr);
		}
		catch (Exception &exception) {
			Application->ShowException(&exception);
		}
	}

	::CoUninitialize();
	::CloseHandle(hMutex);

	return 0;
}
//---------------------------------------------------------------------------
